;===============================================================;
;                                                               ;
; Alien Breed 5                                                 ;
; Cut scene routines (CE)                                       ;
;                                                               ;
;===============================================================;

;------------------------------------------------
; doCutScene - show a cut scene
;   input:  B = cut scene #
;           HL => palette for image
;   output: none
;------------------------------------------------
doCutScene:
        push    bc
        push    hl
        
        ; unpack image
        ld      hl,(pDatFile)
        ld      de,images
        add     hl,de                           ; HL => huffman archive
        ld      de,sbuf
        ld      ix,huffTree
        call    HuffExtr
        
        call    fadeOutClear
        pop     hl
        ld      (__cutscenePal),hl
        call    draw4bppImage
        call    fadeOut
        call    vramFlip
        call    fadeIn
        
        ld      b,200
        call    shortDelay
        pop     hl
        jr      c,cutsceneDone
        
        ld      l,3
        mlt     hl
        ld      de,cutsceneTable
        add     hl,de
        ld      de,(hl)
        ld      hl,(pDatfile)
        add     hl,de
        ld      b,(hl)                          ; B = # of pages
        inc     hl                              ; HL => start of text data
        
cutsceneLoop:
        push    bc
        push    hl
__cutscenePal           = $+1
        ld      hl,$000000
        call    draw4bppImage
        call    vramFlip
        pop     hl
        call    displayPageNoClear
        push    hl
        ld      bc,500
        call    longDelay
        pop     hl
        pop     bc
        jr      c,cutsceneDone
        djnz    cutsceneLoop
        
cutsceneDone:
        call    fadeOutClear
        ret

.end
