#ifdef FPS_TIMER_ON

; USAGE

; need to define these variables (24-bits each)
;   fpsC
;   fpsDisp (this is the value to display)

; invoke INI_FPS_TIMER() to initialise before entering the main loop
; invoke FPS_FRAME() once during each loop
; 24-bit value fpsDisp is the current FPS

#define INI_FPS_TIMER() call iniFpsTimer
iniFpsTimer:
        ld      ix,mpTmrCtrl
        ld      a,(ix)
        and     %11111110                       ; timer 1 disable
        ld      (ix),a
        ld      hl,32768                        ; timer 1 reset value
        ld      (mpTmr1Load),hl
        ld      (mpTmr1Counter),hl
        ld      a,(ix+1)
        and     %11111110                       ; timer 1 count down
        ld      (ix+1),a
        ld      a,(ix)
        or      %00000111                       ; timer 1 enable, 32768Hz, generate interrupt @ 0
        ld      (ix),a
        ld      hl,0
        ld      (fpsC),hl
        ld      (fpsDisp),hl
        ret

#define FPS_FRAME() ld hl,fpsC \ inc (hl) \ ld ix,mpTmrIntStatus \ bit 2,(ix) \ call nz,fpsInt

fpsInt:
        ld      hl,(fpsC)
        ld      (fpsDisp),hl
        xor     a
        ld      (fpsC),a
        ld      a,%00000100
        ld      (ix),a
        ret

#endif


#ifndef FPS_TIMER_ON

#define INI_FPS_TIMER() nop
#define FPS_FRAME() nop

#endif

.end
