;===============================================================;
;                                                               ;
; Alien Breed 5                                                 ;
; Pause routines (CE only)                                      ;
;                                                               ;
;===============================================================;

;------------------------------------------------
; teacherKey - turn the calc off, and when turned back on, go to the pause screen
;   input:  none
;   output: none
;------------------------------------------------
teacherKey:
        ; fall through to pauseScreen

;------------------------------------------------
; pauseScreen - display the pause screen and wait for either [ENTER] or [CLEAR]
;   input:  none
;   output: none
;------------------------------------------------
pauseScreen:
        call    keyScan
        ld      a,(kbdG1)
        bit     kbitMode,a
        jr      nz,pauseScreen                  ; wait until [MODE] is released
        call    _getcsc                         ; clear key buffer

        call    copyVram
        RECT_POS(32,32)
        RECT_SIZE(256,176)
        ld      a,COLOUR_LIGHTBLUE
        call    drawWindow
        RECT_POS(34,34)
        RECT_SIZE(252,15)
        ld      a,COLOUR_LIGHTBLUE
        call    fillRect
        RECT_POS(34,191)
        RECT_SIZE(252,15)
        ld      a,COLOUR_LIGHTBLUE
        call    fillRect

        ld      ix,strPaused
        call    printBlock
        
        ; show 1UP score
        ld      hl,(p1s)
        ld      de,191
        ld      c,53
        call    showHL
        ; show 2UP score
        ld      hl,(p2s)
        ld      de,191
        ld      c,65
        call    showHL
        ; show credits
        ld      hl,(credits)
        ld      de,191
        ld      c,90
        call    showHL
        
        ; show weapons
        ld      hl,pauseWeaponTable
        ld      bc,6*256+1
pauseWeaponLoop:
        push    bc
        push    hl
        ld      a,(weaponTable)
        and     c
        ld      ix,strYes
        jr      nz,pwPrint
        ld      ix,strNo
pwPrint:
        ld      l,(hl)
        ld      de,231
        call    printString
        pop     hl
        inc     hl
        pop     bc
        rlc     c
        djnz    pauseWeaponLoop

        call    vramFlip

pauseKeyLoop:
        call    waitKey
        cp      GK_STAT
        jr      z,pauseAchievements
        cp      GK_2ND
        jr      z,pauseFinished
        cp      GK_ENTER
        jr      z,pauseFinished
        cp      GK_CLEAR
        jp      nz,pauseKeyLoop
pauseConfirmRetreat:
        ld      hl,strRetreat
        ld      de,strAreYouSure
        ld      a,1
        call    showInfoBox
        jp      nc,pauseScreen
        ; game over
        pop     hl
        pop     hl                              ; clear stack
        jp      levelExplode

pauseFinished:
        ld      b,INTO_GAME_DELAY
        jp      delay

pauseAchievements:
        call    viewAchievements
        jp      pauseScreen

.end
