;===============================================================;
;                                                               ;
; Alien Breed 5                                                 ;
; In-game Tips routines                                         ;
;                                                               ;
;===============================================================;

;------------------------------------------------
; showTip - show an info box with an in-game tip
;   input:  A = tip id #
;           D = 0 will save gbuf before showing tip, otherwise will not save it
;   output: none
;------------------------------------------------
showTip:
        ld      c,a                             ; C = tip id # (for later)
        ld      b,a                             ; B = # rotates to perform (won't be used if 0)
        or      a
        ld      a,%00000001
        jr      z,afterShowTipShift             ; if # = 0, no need to bit shift
showTipShift:
        rlca
        djnz    showTipShift
afterShowTipShift:
        ld      hl,(pTips)                      ; HL => tips flags
        ld      e,a                             ; save bitmask to E
        and     (hl)                            ; check if tip already shown
        ret     nz                              ; if so, we can leave
        ld      a,e                             ; A = bitmask
        or      (hl)
        ld      (hl),a                          ; set tip flag as shown
        push    bc                              ; push tip id # to stack (it was still in C)
        ld      a,d
        or      a                               ; check if should be saving gbuf
        jr      nz,afterShowTipSave
#ifdef TI83PLUS
        bcall(ab5_saveVideo)
#endif
afterShowTipSave:
        pop     hl                              ; L = tip id #
#ifdef TI83PLUS
        ld      h,0
        add     hl,hl
#endif
#ifdef TI84PLUSCE
        ld      h,3
        mlt     hl
#endif
        ld      de,tips
        add     hl,de
        LDHLIND()
        ex      de,hl                           ; DE => tip strings
        ld      hl,strTip
        xor     a                               ; normal info box
#ifdef TI83PLUS
        call    showInfoBox
        bcall(ab5_restoreVideo)
        ret
#endif
#ifdef TI84PLUSCE
        jp      showInfoBox
#endif

.end
